# Architecture Decision Records

|Requirement|Original Text|Decision|
|-----------|-------------|--------|
|IDM.OCM.W-STACK.00008|All component functions MUST be compliant with W3C standards. Credential exchange MUST follow the OIDC SIOP and OID4VC specifications. Proof exchange MUST follow OIDC SIOP and OID4VP specifications. Exchange protocols MUST be developed with extensibility considerations for the purpose of supporting multiple protocols in future iterations.| OIDC SIOP was dropped, because the OID4VC/VP world drifts in the direction of custom flows for credential and presentation exchange on top of authorization requests. If SIOP is in the future required it should be integrated in the auth flows of the AAS. |
|IDM.OCM.W-STACK.00009|All schemas MUST be defined in the predefined identity network. |This requirement was dropped, because OID4VC defines the schemas of credentials directly within the [metadata](https://openid.net/specs/openid-4-verifiable-credential-issuance-1_0-ID1.html#appendix-A.1.1.2)|
|IDM.OCM.W-STACK.00012|The use of endpoints provided by the OCM.W-STACK should be available by providing valid authentication that is in consideration with the [IDM.AA] services especially for using the OIDC flows.|The OID4VC Flows are introducing totally new flows (pre auth flow) which were implemented. Authorization Code Grant is not yet supported, in cause of the lack in OID Draft specification.|
|IDM.OCM.W-STACK.00021|The Connection Manager MUST provide a function that allows a component to subscribe/unsubscribe for connection events to receive updates when the status changes. A list of subscribers MUST be in place and maintained based on the respective implementation(subscribe, unsubscribe MUST be possible). This functionality of publishing events SHOULD be provided via a REST service, but a message bus system can also be considered|This requirement makes no sense more, because the DIDComm V2 Protocol has no "status" as in Didcomm V1/Aries. When a new message is received, the events will be forwarded directly to the NATS or vice versa.|
|IDM.OCM.W-STACK.00026|The Connection Manager MUST support the interface with the TSA in order to get a decision whether a connection should be accepted or not.|Requirement making makes no sense any more because the connection invite is sent just to a special user|
IDM.OCM.W-STACK.00030|The Credential Manager MUST provide a way to receive updates for an ongoing issue credential process. |The "process" as such exists not more in OID4VC, there is an straight forward synchronous issuing forseen in in the latest specs.|
|IDM.OCM.W-STACK.00031/IDM.OCM.W-STACK.00112|The Credential Manager MUST provide an Endpoint or a function to allow the request for disputing a credential for a specific subject DID from another component. Reissuance of credentials to external subject DIDs still require a “trusted” state of the connection existing (by utilizing the Trusted Content Resolver Interface).|This requirement is obsolete, because the newest VC specification contains not anymore "Disputes" as advanced concepts: https://www.w3.org/TR/vc-data-model-2.0/#advanced-concepts (old one: https://www.w3.org/TR/vc-data-model/#disputes)See: https://www.w3.org/TR/2024/CRD-vc-data-model-2.0-20240210/#revision-history "The section on Disputes was removed due to lack of implementations in v1.0 and v1.1." In cause of this, the requirement is dropped, because its not more part of the standard.|
|IDM.OCM.W-STACK.00033|The Credential Manager MUST provide an Endpoint to allow the reissuance of a revoked credential for a specific subject DID from another component once the expiration condition has been met. The credential MUST follow the exact structure of the previously issued credential. The refresh endpoint can be included in the VC.Reissuance of credentials to external subject DIDs still require a “trusted” state of the connection existing (by utilizing the Trustlist Manager).|The credential refresh is handled in the lastest spec version over reissuance instead of refresh. Without Didcomm there is no way to inform the user (no channel exist to holder)|
|IDM.OCM.W-STACK.00034|The Credential Manager MUST provide a function to allow the reissuance of a revoked credential for a specific subject DID from another component once the expiration condition has been met and the credential has been marked as valid for automatic reissuance. The credential MUST follow the exact structure of the previously issued credential.Reissuance of credentials to external subject DIDs still require a “trusted” state of the connection existing (by utilizing the Trustlist Manager).|The credential refresh is handled in the lastest spec version over reissuance instead of refresh. Without Didcomm there is no way to inform the user (no channel exist to holder)|
|IDM.OCM.W-STACK.00043|The Credential Storage functionality MUST be separated in a micro service for the graph functionality as well for high scalable storage for VCs/VP. Especially the chaining of VCs, SHOULD be a separated service to avoid the mixing of Graph Technology, Proof Formats and Common Database Technology. If this is not possible, an alternative solution MUST be provided which fulfills the goal of splitting the functionality in specialized services. The general goal MUST be to provide microservices which are able to extract a graph of Json objects belonging to a key (e.g. ID), provide high scalable storage to read Json objects (e.g. a document based storage), provide an component which is able to sign a graph, provide a component which is able to visualize and filter the existing content, provide credential encryption and an appropriate key management solution (e.g. Hashicorp Vault).|The service contains modularity for Security, a cassandra db and integrated graph function, there was no MS required, we provired the functions as libraries|
|IDM.OCM.W-STACK.00046/IDM.OCM.W-STACK.00047/IDM.OCM.W-STACK.00048|Creates and publishes the Public Profile Endpoint. It serves the Self-Description of the organization. It is composed of all the Verifiable Credentials that the administrators or the Trust Services mark as “public”.| After the spec writing there was a change in the catalog and sd specification which considered the sd specification as "Self Declaration" which is mostly a Presentation Definition which can be optained from wallet/storage service if required. This requirement is therefore outdated und makes no sense anymore, because it will be solved by the catalog/self declaration implementation.|
|IDM.OCM.W-STACK.00053|The DID Document Storage MUST provide interfaces for [EBSI] and IPFS to anchor DID Documents within these systems when the features are enabled. In the case of not using these features DID Web as a Service11 (generating DID Documents on the fly) built on TSA basis MUST be the default for generating and managing DID documents.|EBSI was dropped, because it's handled almost like closed source. IPFS was implemented, but the OID4VC Protocols avoid using DIDs, which makes it extremly hard to integrate it against the OIDC specs. It can be used, but it was not integrated due this unclear statements from the spec groups.|
|IDM.OCM.W-STACK.00054| The Credential Signer MUST be an endpoint that allows signing of Verifiable Credentials and other messages with different types of proof: ● QES proof● Linked proof● Provenance proof● Selective Disclosure proofs (e.g., BBS+12) ● Other proofs|From this list was just provenance proof,ld proof and sd proof implemented, because the others are still not yet clearly defined.|
|IDM.OCM.W-STACK.00055| see 55 (just for verification) |See 55, it's the same for verification.|
|IDM.OCM.W-STACK.00056| A concept to support QES MUST be implemented and documented. |See 55|
|IDM.OCM.W-STACK.00059|The Schema Manager Service MUST expose endpoint/s that allow the management of schemas (e.g., Create, Update, Get, Resolve schema) to dock different APIs for schema creation like EBSI.|This was in relation to schema registrar which was not tendered, so this is obsolete. OID4VC defines as well a strange variant for schema registration within metadata, which makes it difficult to "anchor" a schema without that metadata.|
|IDM.OCM.W-STACK.00060|The Schema Manager MUST be able to Create, Update, Get and Resolve schema content through the Verifiable Ledger Abstraction.|In the oidc spec is no schema anchoring anymore, its all shifted to json ld. IPFS can be used for this or any other web service.|
|IDM.OCM.W-STACK.00061|The Verifiable Ledger Abstraction interfaces with and links Schema Manager and the Credential Schema Verifier. It must implement a level of abstraction that allows interchangeability and, if possible, interoperability between different verifiable ledgers. [EBSI]MUST be one of the options for a verifiable ledger|EBSI is almost closed source and has not much benefit for the community. IPFS has more value for the community, but is also bad supported by OID4VC. Therefore ipfs was implemented but not integrated in cause of "fight" against the OIDC spec way forward.|
|IDM.OCM.W-STACK.00066|The used technologies MUST have consistency. Standard technologies e.g., Databases MUST be abstracted over JDBC, authentication over OIDC etc.|JDBC applies not to Cassandra in a sensefull way. OIDC is used.|
|IDM.OCM.W-STACK.00073|Additionally, the Charts MUST provide Istio Resource (e.g., Authorization Rules, Virtual Services etc. ) following the integration pattern specified in the gxfs-integration repo|Technology Agnostic approach avoided istio, otherwise all users are forced to use it.|
|IDM.OCM.W-STACK.00074|All HELM charts MUST be provided with Istio support aligned together with the project team. This consists of Authorization Rules, Virtual Service Definitions and other relevant Istio Definitions which are required for integration in a Istio Environment.|Technology Agnostic approach avoided istio, otherwise all users are forced to use it.|
|IDM.OCM.W-STACK.00076|All helm charts/services MUST provide metrics endpoints in opentelemetry18 format.|Not really "tracable" items in the implementation. Kubernetes metrics should be enough for the moment|
|IDM.OCM.W-STACK.00077|Environment specific parameters MUST be configurable over the helm templates by using profiles. Each component MUST be delivered minimum for profile: - DEV, a local environment for round trip development and testing - Acceptance, a restricted resource environment (with minimal system requirements) which can be deployed in cluster (remote or locally) - Prod, a scalable environment with fault tolerance, HA settings and security hardening|Dev/Prod not really selectable.|
|IDM.OCM.W-STACK.00087|Scalability and Performance around the high workload scenarios MUST be demonstrated, by using any kind of Load Test Framework for HTTP APIs. |Are too environment specific. Local not really sensefull, environment is limited and the most services ares user specific which makes no sense anymore.|
|IDM.OCM.W-STACK.00088|Automation Integration tests must be created, and they must be runnable by a CI job|Gitlab Runner has no possibility to execute docker container within the current environment|
|IDM.OCM.W-STACK.00090|All eventings must be demonstrated on basis of cloud events [Cloud Events] specifications together with the kNative19 broker together with NATS in a KKubernetes environment. |kNative is not integrated but cloud events is there|
|IDM.OCM.W-STACK.00093|The helm chart MUST be able to install inside of Argo CD. This includes the usage of the postgres hooks20 and the providing of usable values.yaml(s) for all developed services|The helmcharts are argo ready, but not tested with argo in cause of support lack|
|IDM.OCM.W-STACK.00098|Schemas are defined in the external network and are resolvable.|see IDM.OCM.W-STACK.00059|
|IDM.OCM.W-STACK.00100|A middleware for authentication in order to use the exposed endpoints is provided as well as the possibility to be integrated with the [IDM.AA] Services|OID4VC endpoints support in the moment not really authentication code flow, they all  go for pre auth flow, so this is dropped.|
|IDM.OCM.W-STACK.00123|A Public Profile Endpoint exists and serves the Self-Declaration of the organization in the format of signed VP.|New Self Declaration Spec is still not released and the most SDs are pushed after clearing house directly into catalog as file transfer. So this requirement makes no sense so long the new SD spec is not implemented.|
|IDM.OCM.W-STACK.00124|The Public Profile Endpoint can be updated successfully, and the endpoints are available in the DID Documents during resolving.|New Self Declaration Spec is still not released and the most SDs are pushed after clearing house directly into catalog as file transfer. So this requirement makes no sense so long the new SD spec is not implemented.|
|IDM.OCM.W-STACK.00125|The Public Profile Endpoint can be deleted successfully and the did document does not contain the endpoint anymore after resolving.|The Public Profile Endpoint can be updated successfully, and the endpoints are available in the DID Documents during resolving.|New Self Declaration Spec is still not released and the most SDs are pushed after clearing house directly into catalog as file transfer. So this requirement makes no sense so long the new SD spec is not implemented.|
|IDM.OCM.W-STACK.00128|The Dispute Section can be linked successfully, and a credential contains the correct values during issuing|Dropped. See Dispute Requirement.|
|IDM.OCM.W-STACK.00131|The DID Document Manager interfaces with the TSA at the appropriate times / places, if applicable. TSA is used to verify incoming connection for blacklist entries, incoming DID, IP address etc. and TSA is used for issuing/receiving credentials for trusted parties and connections| Dropped because connections exist not really in OID4VC anymore. |
|IDM.OCM.W-STACK.00132|The Credential Signer successfully signs a Credential with an eIDAS compliant signature which is verifiable with the DSS framework|eIDAS 2.0 QEAA creation is not yet clearify defined for credentials, therefore this requirement is on hold.|
|IDM.OCM.W-STACK.00133|The Credential Verifier successfully proves the signature on a Credential by using the DSS Framework. | eIDAS 2.0 QEAA verification is not yet clearify defined for credentials, therefore this requirement is on hold. |
|IDM.OCM.W-STACK.00135|The concept is prepared, and connectable to a QES TSP|Dropped. Is still not clarified, how this shall work in eIDAS 2.0. Concepts are ongoing, HSM connection is prepared, let's wait for final decisions by the ARF Working groups and large scale pilots| 
|IDM.OCM.W-STACK.00138|The exposed endpoints are demonstrated to effectively and securely create, update, get and resolve schemas|Dropped because Schemas are not supported anymore in OID4VC and hardcoded in metadata.|
|IDM.OCM.W-STACK.00139|The create, update, get and resolve functionality is securely accessible through the endpoints| Dropped. See 138|
|IDM.OCM.W-STACK.00140|Schemas are created, resolvable and read on the verifiable ledger, one of which is EBSI Schemas are also creatable and resolvable from IPFS Gateways and from Webservers.| Dropped. See 138|
|General|Didcomm v2 Usage| Didcomm v2 is in the moment in a state where it can be used somehow, but there are a lot of gaps for interpretations. This is also one reason why nobody has it implemented in the moment and focusing more on OID4VC stateless protocols. Therefore the didcomm implementation was downranked, in cause of the less importance.| 
 
